## maria 1.3.5

=== Makefile ===
### Modular Reachability Analyzer -*- makefile -*-

### User-configurable section begins

# Installation directory prefix for Debian GNU/Linux
DESTDIR =
# Generic installation directory prefix
PREFIX = /usr

# Where to find GraphViz lefty?
LEFTYBIN = $(PREFIX)/bin/lefty
# Where to put binaries on 'make install'?
BINDIR = $(PREFIX)/bin
# Where to put architecture-independent runtime files on 'make install'?
RTDIR = $(PREFIX)/share/maria/runtime
# Where to put architecture-independent example files on 'make install'?
EXDIR = $(PREFIX)/share/maria/examples
# Where to put on-line documentation on 'make installinfo'?
INFODIR = $(PREFIX)/share/info
# Where to put manual pages on 'make installman'?
MANDIR = $(PREFIX)/share/man/man1

## Extra definitions
### use mmap(2) if available, to optimise performance
EXTRA_DEFINES = -DUSE_MMAP
### emulate mmap(2) with malloc(3) to obtain reliable memory usage statistics
#EXTRA_DEFINES := $(EXTRA_DEFINES) -DUSE_MMAP -DNO_MMAP
### in modular analysis, enable the caching of local successor states
#EXTRA_DEFINES := $(EXTRA_DEFINES) -DSYNC_CACHE
### in modular analysis, enable the caching of pre-synchronisation states
#EXTRA_DEFINES := $(EXTRA_DEFINES) -DADD_CACHE

## Debugging
### -DNDEBUG omits assert(3) macros
### -DYYDEBUG enables grammar debugging if DEBUG=1 (see parser/maria.C)
### -g includes debugging symbols in the objects and the executable
DEBUG = -DNDEBUG
#DEBUG = -g # -DYYDEBUG
## Profiling
#PROF = -pg
PROF =

### Installation commands
INSTALLDIR = install -d
INSTALLBIN = install -c
INSTALLDATA = install -c -m 444
RM = rm -f

### User-configurable section ends

LTL_INCLUDES = $(BUILTIN_LTL:yes=-IAutomata/Ltl)
LTL_DEFINES = $(BUILTIN_LTL:yes=-DBUILTIN_LTL)

COMP_INCLUDES = $(EXPR_COMPILE:yes=-ICompilation/base)
COMP_DEFINES = $(EXPR_COMPILE:yes=-DEXPR_COMPILE)

CPPFLAGS = $(EXTRA_INCLUDES) $(INCLUDES) $(LTL_INCLUDES) $(COMP_INCLUDES) \
	$(DEFINES) $(EXTRA_DEFINES) $(LTL_DEFINES) $(COMP_DEFINES) $(DEBUG)

LEX=flex
LFLAGS=-o$@
YACC=bison
YFLAGS=-d

TARGET = maria

COMMONSRCS = \
	parser/util.C \
	parser/StringBuffer.C \
	parser/VariableStackMap.C \
	parser/Printer.C \
	parser/NameList.C

AUTSRCS = \
	Automata/Property.C \
	Automata/PropertyState.C \
	Automata/BitVector.C \
	Automata/SetList.C \
	Automata/Product.C

GRAPHSRCS = \
	Graph/Graph.C \
	Graph/ComponentGraph.C \
	Graph/Search.C \
	Graph/BitBuffer.C \
	Graph/ByteBuffer.C \
	Graph/BTree.C \
	Graph/States.C \
	Graph/StateReporter.C \
	Graph/StateSetReporter.C \
	Graph/GraphReporter.C \
	Graph/DummyReporter.C \
	Graph/SyncStates.C \
	Graph/StateSet.C \
	Graph/FullSet.C \
	Graph/ParSet.C \
	Graph/CompactSet.C \
	Graph/HashGraph.C \
	Graph/StateList.C \
	Graph/LSTS.C

EXPRSRCS = \
	Expression/Function.C \
	Expression/Substitution.C \
	Expression/ExpressionList.C \
	Expression/ExpressionSet.C \
	Expression/ExpressionMSet.C \
	Expression/Expression.C \
	Expression/Typecast.C \
	Expression/Variable.C \
	Expression/Constant.C \
	Expression/Undefined.C \
	Expression/StructExpression.C \
	Expression/StructComponent.C \
	Expression/StructAssign.C \
	Expression/UnionExpression.C \
	Expression/UnionComponent.C \
	Expression/UnionTypeExpression.C \
	Expression/VectorExpression.C \
	Expression/VectorIndex.C \
	Expression/VectorAssign.C \
	Expression/VectorShift.C \
	Expression/UnopExpression.C \
	Expression/BinopExpression.C \
	Expression/BufferExpression.C \
	Expression/BufferWrite.C \
	Expression/BufferUnop.C \
	Expression/BufferRemove.C \
	Expression/BufferIndex.C \
	Expression/IfThenElse.C \
	Expression/BooleanBinop.C \
	Expression/NotExpression.C \
	Expression/RelopExpression.C \
	Expression/SetExpression.C \
	Expression/TemporalUnop.C \
	Expression/TemporalBinop.C \
	Expression/CardinalityExpression.C \
	Expression/TransitionQualifier.C \
	Expression/PlaceContents.C \
	Expression/Submarking.C \
	Expression/Mapping.C \
	Expression/EmptySet.C \
	Expression/Quantifier.C \
	Expression/Marking.C \
	Expression/Token.C \
	Expression/VariableSet.C

NETSRCS = \
	Net/LNet.C \
	Net/Net.C \
	Net/Place.C \
	Net/Transition.C \
	Net/Arc.C \
	Net/PlaceMarking.C \
	Net/GlobalMarking.C \
	Net/VariableDefinition.C

TYPESRCS = \
	Type/Type.C \
	Type/IntType.C \
	Type/CardType.C \
	Type/BoolType.C \
	Type/CharType.C \
	Type/EnumType.C \
	Type/IdType.C \
	Type/StructType.C \
	Type/UnionType.C \
	Type/VectorType.C \
	Type/BufferType.C \
	Type/ComponentList.C \
	Type/Range.C \
	Type/Constraint.C

VALUESRCS = \
	Value/Value.C \
	Value/ValueList.C \
	Value/LeafValue.C \
	Value/StructValue.C \
	Value/UnionValue.C \
	Value/VectorValue.C \
	Value/BufferValue.C \
	Value/Valuation.C

LTLSRCS = \
	Automata/Ltl/Ltl.C \
	Automata/Ltl/LtlGraph.C \
	Automata/Ltl/LtlBitVector.C
LTLOPTSRCS = \
	$(BUILTIN_LTL:yes=Automata/Ltl/Ltl.C) \
	$(BUILTIN_LTL:yes=Automata/Ltl/LtlGraph.C) \
	$(BUILTIN_LTL:yes=Automata/Ltl/LtlBitVector.C)

COMPSRCS = \
	Compilation/base/CExpression.C \
	Compilation/base/Compilation.C
COMPOPTSRCS = \
	$(EXPR_COMPILE:yes=Compilation/base/CExpression.C) \
	$(EXPR_COMPILE:yes=Compilation/base/Compilation.C)

PARSERSRCS = \
	parser/maria.tab.C parser/lex.pn.C \
	parser/marde.tab.C parser/lex.de.C
PARSERHDRS = \
	parser/maria.tab.h parser/marde.tab.h

AUX = $(PARSERSRCS) $(PARSERHDRS)

CSRCS = parser/cmdline.c
CORESRCS = $(COMMONSRCS) $(EXPRSRCS) $(NETSRCS) $(TYPESRCS) $(VALUESRCS) \
	 $(GRAPHSRCS) $(AUTSRCS) $(LTLOPTSRCS) $(COMPOPTSRCS)
CXXSRCS = $(CORESRCS) parser/maria.C parser/server.C parser/Dotty.C

SRCS = $(CXXSRCS) $(PARSERSRCS) $(CSRCS)
OBJS = $(CXXSRCS:.C=.o) $(PARSERSRCS:.C=.o) $(CSRCS:.c=.o)
LIBS = $(EXTRA_LIBS) $(LIBREADLINE)

INCLUDES = -Iparser -IExpression -INet -IType -IValue \
	-IGraph -IAutomata $(INCREADLINE)

INFO = doc/maria.info
MANPAGES = maria.1 maria-cso.1 maria-vis.1

error:
	@echo "Type 'make -f Makefile.`uname`' to compile Maria"; exit 1

real-all: $(TARGET)

clean:
	$(RM) $(OBJS) $(LTLSRCS:.C=.o) $(COMPSRCS:.C=.o)

reallyclean: clean
	$(RM) $(TARGET) $(AUX) $(INFO)

install: $(TARGET)
	$(INSTALLDIR) $(DESTDIR)$(BINDIR)
	$(INSTALLDIR) $(DESTDIR)$(RTDIR)
	$(INSTALLDIR) $(DESTDIR)$(EXDIR)
	$(INSTALLBIN) maria $(DESTDIR)$(BINDIR)
	$(INSTALLBIN) maria-vis $(DESTDIR)$(BINDIR)
	$(INSTALLBIN) maria-cso $(DESTDIR)$(BINDIR)
	sed -e 's:^#!/.*/lefty$$:#!$(LEFTYBIN):' maria-vis > $(DESTDIR)$(BINDIR)/maria-vis
	sed -e 's:^ *INCLUDES=.*:INCLUDES="-I$(RTDIR)":' maria-cso > $(DESTDIR)$(BINDIR)/maria-cso
	for i in Compilation/runtime/*.h; do $(INSTALLDATA) "$$i" $(DESTDIR)$(RTDIR); done
	for i in parser/test/*.pn; do $(INSTALLDATA) "$$i" $(DESTDIR)$(EXDIR); done

installinfo: $(INFO)
	$(INSTALLDIR) $(DESTDIR)$(INFODIR)
	$(INSTALLDATA) $(INFO) $(DESTDIR)$(INFODIR)

installman: $(MANPAGES)
	$(INSTALLDIR) $(DESTDIR)$(MANDIR)
	for i in $(MANPAGES); do $(INSTALLDATA) "$$i" $(DESTDIR)$(MANDIR); done

info: $(INFO)

depend:
	touch $@ && makedepend -f$@ -Y $(CPPFLAGS) $(SRCS) 2> /dev/null

$(TARGET): $(OBJS)
	$(CXX) $(LDFLAGS) $(PROF) -o $@ $(OBJS) $(LIBS)

parser/maria.tab.C parser/maria.tab.h: parser/maria.y
	(cd parser && $(YACC) $(YFLAGS) -p pn maria.y)
	mv parser/maria.tab.c parser/maria.tab.C

parser/marde.tab.C parser/marde.tab.h: parser/marde.y
	(cd parser && $(YACC) $(YFLAGS) -p de marde.y)
	mv parser/marde.tab.c parser/marde.tab.C

parser/lex.pn.C: parser/maria.lex parser/maria.tab.h
	$(LEX) $(LFLAGS) parser/maria.lex

parser/lex.de.C: parser/marde.lex parser/marde.tab.h
	$(LEX) $(LFLAGS) parser/marde.lex

.phony: all clean reallyclean install installinfo installman info

.SUFFIXES:
.SUFFIXES: .o .c .C .info .texinfo

.c.o:
	$(CC) $(CPPFLAGS) $(PROF) $(CFLAGS) -c $< -o $@
.C.o:
	$(CXX) $(CPPFLAGS) $(PROF) $(CXXFLAGS) -c $< -o $@
.texinfo.info:
	makeinfo --no-split $< -o $@

include depend

=== debian/changelog ===
maria (1.3.5-6) unstable; urgency=medium

  * Team upload.
  
  [ Andreas Tille ]
  * Point Vcs fields to Salsa
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * rename debian/NEWS.Debian debian/NEWS (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Remove constraints unnecessary since bullseye (oldstable):
    + Build-Depends: Replace dependency on transitional package libncurses5-dev
      with replacement libtinfo6, libncurses-dev.
  * watch file standard 4 (routine-update)
  * Build with dh-elpa
  * Lintian-overrides for natinal encoding
  * Propagate hardening options

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_build pass cross tools to make.
    Closes: #962547

 -- Andreas Tille <tille@debian.org>  Tue, 05 Nov 2024 08:21:26 +0100

maria (1.3.5-5) unstable; urgency=medium

  * debian/rules: rewrite from scratch, using dh

 -- Ralf Treinen <treinen@debian.org>  Thu, 27 Oct 2016 21:52:06 +0200

maria (1.3.5-4) unstable; urgency=low

  * debian/control:
    - set section to science
    - set priority to extra
    - set maintainer to debian-science
    - add Vcs-Git/Browse fields
  * Simplify invocations to debhelpers in debian/rules
  * patch utf8: migrate NEWS file to utf8

 -- Ralf Treinen <treinen@debian.org>  Fri, 13 May 2011 21:59:53 +0200

maria (1.3.5-3) unstable; urgency=low

  * Patch gcc4.6: add missing #includes to fix FTBFS with gcc4.6
    (closes: #624926).
  * Standards-Version 3.9.2 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 03 May 2011 07:13:20 +0200

maria (1.3.5-2) unstable; urgency=low

  * debhelper compatibility level 7.
  * Standards-Version 3.8.3 (no change)
  * Convert to source format 3.0 (quilt):
    - debian/patches in quilt style
    - no more patching in debian/rules
    - no more build-dependency on dpatch
    - added debian/source/format
    - remove debian/README.source
  * debian/control:
   - add dependency on ${misc:Depends}
   - change dependency on libreadline5-dev to libreadline-dev (closes: #553809)
   - remove obsolete build-dependency on xutils
   - add Homepage field
  * debian/copyright:
    - converted to UTF-8
    - point to GPL-2 file instead of GPL file
  * debian/maria-doc.doc-base:
    - section Science/Mathematics
    - fieldname "authors" corrected to "author"
    - converted to UTF-8
  * debian/rules:
    - "dh_clean -k" => "dh_prep"
    - "make reallyclean" => "make clean" since the former seems to be
      the cause of segfaults, explicitly remove maria and doc/maria.info
      (closes:  Bug#544575).
    - do not ignore errors of "make clean"
    - fix clean target to remove generate html files in doc
  * Changed recommendation of infobrowser to info (package maria-doc)

 -- Ralf Treinen <treinen@debian.org>  Sun, 22 Nov 2009 13:02:15 +0100

maria (1.3.5-1) unstable; urgency=low

  * New upstream release.
  * Desactivated patch 03gcc40, seems to be fixed by upstream.
  * Install upstream NEWS file as /usr/share/doc/*/changelog.

 -- Ralf Treinen <treinen@debian.org>  Mon,  8 Aug 2005 12:32:36 +0200

maria (1.3.4-7) unstable; urgency=low

  * Compile with "-O3" instead of "-O2" on m68k to work around a FTBFS
    caused by a gcc-4.0 bug.
  * texi2html now produces *html files in subdirectory "maria/"

 -- Ralf Treinen <treinen@debian.org>  Fri,  5 Aug 2005 12:38:59 +0200

maria (1.3.4-6) unstable; urgency=low

  * Standards Version 3.6.2 (no changes).
  * Some minor improvements in README.examples.
  * Rebuild with gcc 4.

 -- Ralf Treinen <treinen@debian.org>  Wed,  6 Jul 2005 20:44:25 +0200

maria (1.3.4-5) unstable; urgency=low

  * The binary package maria-vis is no longer build since graphviz is
    now in main. The package maria now replaces and conflicts with
    maria-vis. (closes: Bug#292595).
  * debian/copyright: distinguish copyright and licence.
  * Removed the lintian override concerning unusual interpreter lefty -
    this is now a lintian bug.
  * Wrote README.examples, put it in /usr/share/doc/maria/examples
  * Removed spurious $(CURDIR) in debian/rules

 -- Ralf Treinen <treinen@debian.org>  Sun, 13 Feb 2005 17:17:51 +0100

maria (1.3.4-4) unstable; urgency=low

  * Use dpatch. Dpatchify old patches:
    - 01lefty_path: fix path of lefty interpreter
    - 02compile_options: fix compile flags
  * Patch 03gcc40: Fix compilation error for gcc4.0 on amd64. Patch
    contributed by Andreas Jochens - thanks! (closes: Bug#288926)
  * Short descriptions start on a lowercase letter.
  * Removed useless ${misc:Depends} from maria's Dependency.
  * Removed debian/TODO.

 -- Ralf Treinen <treinen@debian.org>  Thu,  6 Jan 2005 20:48:05 +0100

maria (1.3.4-3) unstable; urgency=low

  * Switch from libreadline4 to libreadline5.

 -- Ralf Treinen <treinen@debian.org>  Sat,  1 Jan 2005 18:19:33 +0100

maria (1.3.4-2) unstable; urgency=low

  * Converted this changelog file to UTF-8
  * Package maria-doc: added Recommends infobrowser
  * Standards-version 3.6.1 (no change)
  * Added a debian/watch file
  * Added a lintian override for maria-vis concering the use of lefty as
    an interpreter

 -- Ralf Treinen <treinen@debian.org>  Wed,  4 Aug 2004 09:54:50 +0200

maria (1.3.4-1) unstable; urgency=low

  * New upstream release
  * Standards-Version: 3.6.0
  * Use a file debian/compat instead of variable DH_COMPAT in debian/rules
  * Installation of info files: don't attempt to install  maria.info-*

 -- Ralf Treinen <treinen@debian.org>  Mon,  4 Aug 2003 23:01:40 +0200

maria (1.3.3-1) unstable; urgency=low

  * New upstream release. This release should compile on gcc 3.0 (closes:
    Bug#171226).

 -- Ralf Treinen <treinen@debian.org>  Mon,  9 Dec 2002 21:48:45 +0100

maria (1.3.2-1) unstable; urgency=low

  * New upstream release.
  * Applied a patch to maria.texinfo sent by Marko Mäkelä.


=== debian/control ===
Source: maria
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-elpa,
               libreadline-dev,
               libtinfo6,
               libncurses-dev,
               flex,
               bison
Build-Depends-Indep: texinfo,
                     texi2html
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/maria
Vcs-Git: https://salsa.debian.org/science-team/maria.git
Homepage: http://www.tcs.hut.fi/Software/maria/
Rules-Requires-Root: no

Package: maria
Architecture: any
Section: math
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: maria-doc,
            lbt,
            graphviz
Conflicts: maria-vis
Replaces: maria-vis
Description: reachability analyzer for Algebraic System Nets
 Maria is a powerful tool designed to aid engineers in modelling and
 solving concurrency related problems in parallel and distributed
 computing systems.
 .
 Maria finds deadlocks and violations against safety or liveness
 requirements by exploring all states that can be reached from the
 initial state of a system.  The tool manages tens or hundreds of
 millions of reachable states and enabled actions.
 .
 The expressive power of Maria's formalism is close to high-level
 programming languages, thanks to its rich data type system and
 powerful algebraic operations.

Package: maria-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: maria,
            info | info-browser | www-browser
Description: documentation of Maria
 This package contains the documentation of Maria, a reachability
 analyzer for algebraic system nets, both in the formats info and html.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with elpa

override_dh_auto_configure:

override_dh_auto_build-arch:
	dh_auto_build -a --buildsystem=makefile -- -f Makefile.Linux CXXOPTFLAGS=$(OPTFLAGS)

override_dh_auto_build-indep:
	cd doc \
		&& makeinfo maria.texinfo \
		&& texi2html -split chapter maria.texinfo

override_dh_auto_install-indep:
	echo "Do not trigger make again"

=== debian/watch ===
version=4
http://www.tcs.hut.fi/Software/maria/src/maria-([\d.]*)\.tar\.gz
